DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
DiMonoPixel Class Referenceabstract

Abstract base class to handle monochrome pixel data. More...

Inheritance diagram for DiMonoPixel:

## Public Member Functions
| DiMonoPixel (const unsigned long count)
| constructor More...
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor More...
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes More...
virtual int | getMinMaxValues (double &min, double &max) const =0
| get minimum and maximum pixel values (abstract) More...
virtual int | getMinMaxWindow (const int idx, double &center, double &width)=0
| get automatically computed min-max window (abstract) More...
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)=0
| get automatically computed Region of Interest (ROI) window (abstract) More...
virtual int | getHistogramWindow (const double thresh, double &center, double &width)=0
| get automatically computed histogram window (abstract) More...
unsigned int | getBits () const
| get number of bits per pixel More...
double | getAbsMinimum () const
| get absolute minimum pixel value. More...
double | getAbsMaximum () const
| get absolute maximum pixel value. More...
double | getAbsMaxRange () const
| get absolute pixel range More...
const char * | getModalityLutExplanation () const
| get modality LUT explanation string More...
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object More...
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed. More...
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor More...
virtual | ~DiPixel ()
| destructor
virtual EP_Representation | getRepresentation () const =0
| get integer representation (abstract) More...
virtual const void * | getData () const =0
| get pointer to pixel data (abstract). More...
virtual void * | getDataPtr ()=0
| get pointer to pixel data (abstract). More...
virtual void * | getDataArrayPtr ()=0
| get pointer to array of pixel data (abstract). More...
unsigned long | getCount () const
| get number of pixels More...
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element More...

## Protected Member Functions
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor More...

## Protected Attributes
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Detailed Description

Abstract base class to handle monochrome pixel data.

## Constructor & Destructor Documentation

## ◆ DiMonoPixel() [1/5]

DiMonoPixel::DiMonoPixel | ( | const unsigned long | count | ) |

constructor

Parameters

  count | number of pixels

## ◆ DiMonoPixel() [2/5]

DiMonoPixel::DiMonoPixel | ( | const DiInputPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |

constructor

Parameters

  pixel | pointer to input pixel data
  modality | pointer to object managing modality transform

## ◆ DiMonoPixel() [3/5]

DiMonoPixel::DiMonoPixel | ( | DiMonoOutputPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |

constructor

Parameters

  pixel | pointer to output pixel data used for intermediate representation
  modality | pointer to object managing modality transform

## ◆ DiMonoPixel() [4/5]

DiMonoPixel::DiMonoPixel | ( | const DiPixel * | pixel,
|  | DiMonoModality * | modality
| ) |  |
| protected

constructor

Parameters

  pixel | pointer to intermediate pixel data (not necessarily monochrome)
  modality | pointer to object managing modality transform

## ◆ DiMonoPixel() [5/5]

DiMonoPixel::DiMonoPixel | ( | const DiMonoPixel * | pixel,
|  | const unsigned long | count
| ) |  |
| protected

constructor

Parameters

  pixel | pointer to intermediate monochrome pixel data
  count | number of pixels

## Member Function Documentation

## ◆ addReferenceToModality()

DiMonoModality* DiMonoPixel::addReferenceToModality | ( |  | ) |

add a reference to the internally managed modality transform object

Returns
  pointer to modality transform object (might be NULL)

## ◆ getAbsMaximum()

double DiMonoPixel::getAbsMaximum | ( |  | ) | const
| inline

get absolute maximum pixel value.

The result depends on former transforms.

Returns
  absolute maximum value

## ◆ getAbsMaxRange()

double DiMonoPixel::getAbsMaxRange | ( |  | ) | const
| inline

get absolute pixel range

Returns
  absolute pixel range

## ◆ getAbsMinimum()

double DiMonoPixel::getAbsMinimum | ( |  | ) | const
| inline

get absolute minimum pixel value.

The result depends on former transforms.

Returns
  absolute minimum value

## ◆ getBits()

unsigned int DiMonoPixel::getBits | ( |  | ) | const
| inline

get number of bits per pixel

Returns
  number of bits

## ◆ getHistogramWindow()

virtual int DiMonoPixel::getHistogramWindow | ( | const double | thresh,
|  | double & | center,
|  | double & | width
| ) |  |
| pure virtual

get automatically computed histogram window (abstract)

Parameters

  thresh | ignore certain percentage of pixels at lower and upper boundaries
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implemented in DiMonoPixelTemplate< T >, and DiMonoPixelTemplate< T3 >.

## ◆ getMinMaxValues()

virtual int DiMonoPixel::getMinMaxValues | ( | double & | min,
|  | double & | max
| ) |  | const
| pure virtual

get minimum and maximum pixel values (abstract)

Parameters

  min | reference to storage area for minimum pixel value
  max | reference to storage area for maximum pixel value

Returns
  status, true if successful, false otherwise

Implemented in DiMonoPixelTemplate< T >, and DiMonoPixelTemplate< T3 >.

## ◆ getMinMaxWindow()

virtual int DiMonoPixel::getMinMaxWindow | ( | const int | idx,
|  | double & | center,
|  | double & | width
| ) |  |
| pure virtual

get automatically computed min-max window (abstract)

Parameters

  idx | ignore global min/max pixel values if > 0
  center | reference to storage area for window center value
  width | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implemented in DiMonoPixelTemplate< T >, and DiMonoPixelTemplate< T3 >.

## ◆ getModalityLutExplanation()

const char* DiMonoPixel::getModalityLutExplanation | ( |  | ) | const
| inline

get modality LUT explanation string

Returns
  modality LUT explanation

## ◆ getPlanes()

int DiMonoPixel::getPlanes | ( |  | ) | const
| inline virtual

get number of planes

Returns
  number of planes (here 1, monochrome)

Implements DiPixel.

## ◆ getRoiWindow()

virtual int DiMonoPixel::getRoiWindow | ( | const unsigned long | left_pos,
|  | const unsigned long | top_pos,
|  | const unsigned long | width,
|  | const unsigned long | height,
|  | const unsigned long | columns,
|  | const unsigned long | rows,
|  | const unsigned long | frame,
|  | double & | voiCenter,
|  | double & | voiWidth
| ) |  |
| pure virtual

get automatically computed Region of Interest (ROI) window (abstract)

Parameters

  left_pos | x-coordinate of the top left-hand corner of the ROI (starting from 0)
  top_pos | y-coordinate of the top left-hand corner of the ROI (starting from 0)
  width | width in pixels of the rectangular ROI (minimum: 1)
  height | height in pixels of the rectangular ROI (minimum: 1)
  columns | number of columns (width) of the associated image
  rows | number of rows (height) of the associated image
  frame | index of the frame to be used for the calculation
  voiCenter | reference to storage area for window center value
  voiWidth | reference to storage area for window width value

Returns
  status, true if successful, false otherwise

Implemented in DiMonoPixelTemplate< T >, and DiMonoPixelTemplate< T3 >.

## ◆ isPotentiallySigned()

int DiMonoPixel::isPotentiallySigned | ( |  | ) | const
| inline

check whether pixel data is 'potentially' signed.

This check is necessary to interpret possibly following LUT descriptors correctly (see supplement 33)

Returns
  true if pixel data is potentially signed, false otherwise

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimopx.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1